// inslude the SPI library:
//#include <SPI.h>

#define  ZERO 0x8
#define  ONE  0xE
#define  MIN  0x88888888
#define  MAX  0xEEEEEEEE
#define  LED_NUMBER  160

struct Struct_Color
{
  unsigned char Red[4], Green[4], Blue[4];
};
typedef	struct Struct_Color	SColor;

int i, j;
SColor Arr[LED_NUMBER];

void Init_LEDs (int Number)
{
  for (i=0; i<Number; i++)
  {
    switch (i%6)
    {
      case 0:
        *((long int *)&Arr[i].Red) = MAX;
        *((long int *)&Arr[i].Green) = MIN;
        *((long int *)&Arr[i].Blue) = MIN;
        break;
      case 1:
        *((long int *)&Arr[i].Red) = MAX;
        *((long int *)&Arr[i].Green) = MAX;
        *((long int *)&Arr[i].Blue) = MIN;
        break;
      case 2:
        *((long int *)&Arr[i].Red) = MIN;
        *((long int *)&Arr[i].Green) = MAX;
        *((long int *)&Arr[i].Blue) = MIN;
        break;
      case 3:
        *((long int *)&Arr[i].Red) = MIN;
        *((long int *)&Arr[i].Green) = MAX;
        *((long int *)&Arr[i].Blue) = MAX;
        break;
      case 4:
        *((long int *)&Arr[i].Red) = MIN;
        *((long int *)&Arr[i].Green) = MIN;
        *((long int *)&Arr[i].Blue) = MAX;
        break;
      case 5:
        *((long int *)&Arr[i].Red) = MAX;
        *((long int *)&Arr[i].Green) = MIN;
        *((long int *)&Arr[i].Blue) = MAX;
        break;
    }
  }
}

void Slide (int Number)
{
  SColor Temp;
  Temp = Arr[0];
  for (i=0; i<Number-1; i++)
    Arr[i] = Arr[i+1];
  Arr[i] = Temp;
}

void Update (int Number)
{
  for (i=0; i<LED_NUMBER; i++)
  {
    for (j=0; j<4; j++)
      SPI.transfer (Arr[i].Red[j]);
    for (j=0; j<4; j++)
      SPI.transfer (Arr[i].Green[j]);
    for (j=0; j<4; j++)
      SPI.transfer (Arr[i].Blue[j]);
  }
  delay (1);
}

void setup()
{
  // SPP Init
  SPI.begin();
  SPI2BRG = 9;

  // Init LED colors
  Init_LEDs (LED_NUMBER);
  
  // Init button
  pinMode (2, INPUT);
  Update (LED_NUMBER);
}


void loop()
{
  if (digitalRead(2) == 0)  // if button is pressed
  {
    Slide (LED_NUMBER);
    Update (LED_NUMBER);
    delay (200);
  }
}

